#!/usr/bin/gawk -f

BEGIN{
  pi=3.1415926535;
  deg=pi/180.;
  OFMT=CONVFMT="%.6f";

  Month["Jan"] = 1;
  Month["Feb"] = 2;
  Month["Mar"] = 3;
  Month["Apr"] = 4;
  Month["May"] = 5;
  Month["Jun"] = 6;
  Month["Jul"] = 7;
  Month["Aug"] = 8;
  Month["Sep"] = 9;
  Month["Oct"] = 10;
  Month["Nov"] = 11;
  Month["Dec"] = 12;

  print "# JD & d [au] & l [deg] & b [deg] & Besselian year & dataset";
}
/\$\$EOE/{
  i=0;
}
!/^#/ && (NF>0) && (i==1){
  split($1,l,"-");
  y = l[1];
  m = Month[l[2]];
  d = l[3];
  split($2,l,":");
  h = l[1];
  min = l[2];
  s = l[3]+0;
  d = d+(h+min/60.+s/3600.)/24.;  # <- here was an ERROR!
  jd = jdate(y,m,d);

#  print "str = ", substr(str,0,10)
#  print "y = ", y
#  print "m = ", m
#  print "d = ", d
#  print "str = ", substr(str,12)
#  print "h = ", h
#  print "min = ", min
#  print "s = ", s

  d = $29;
  l_ = $36;
  b = $37;

  bessel = 1900.0 + (jd - 2415020.31352) / 365.242198781;
  dataset = "-";

  print jd "	" d "	" l_ "	" b "	"  bessel "	" dataset;
}
/\$\$SOE/{
  i=1;
}

func jdate(y,m,d, yy,mm,jd,a,b) {
  if (m > 2) {
    yy = y;
    mm = m;
  } else {
    yy = y - 1.0;
    mm = m + 12.0;
  }
  jd = int(365.25*yy) + int(30.6001*(mm+1)) + d + 1720994.5;
  if ((y > 1582) || (y == 1582) && (m > 10) || (y == 1582) && (m == 10) && (int(d) > 15)) {
    a = int(yy/100.0);
    b = 2.0-a+int(a/4.0);
    jd = jd + b;
  }
  return jd;
}

